unit unharmoz ;
interface
procedure twonorm ; { to unnormalise by two methods }
implementation
uses
  unharstr ; { for function FloatWithPower }
{ 1*2*3*4*...*(n-2)*(n-1)*n }
function togetfactom ( n  : byte ) : extended ; { for n! }
var
  i  : byte ;     { count }
  r  : extended ; { temporary }
  z  : extended ; { temporary }
begin
  r:=1.0;    { initial value }
  if  n > 1  { 0! = 1  1! =1 }
    then
      for i:=2 to n do  { for n! }
        begin
          z:=i;   { current i value }
          r:=r*z; { current i! }
        end;
  togetfactom:=r; { result n! }
end;
{ 1*3*5*7*...*(2n-3)*(2n-1) }
function togetfactos ( n  : byte ) : extended ; { for (2n-1)!! }
var
  i  : byte ;     { count }
  r  : extended ; { temporary }
  z  : extended ; { temporary }
begin
  r:=1.0;           { initial value n > 1 allways }
  for i:=2 to n do  { for (2n-1)!! }
    begin
      z:=2.0*i-1;   { current 2i-1 value }
      r:=r*z;       { current (2i-1)! }
    end;
  togetfactos:=r; { result 1*3*5*7*...*(2n-3)*(2n-1) }
end;
procedure twonorm ; { to unnormalise by two methods }
var
  gemfile  : text ;     { file with coefficients }
  i,k,m,n  : byte ;     { counts }
  p,q,r,z  : extended ; { temporary }
  cnm,snm  : extended ; { coefficients values }
  c,s,a,b  : extended ;
begin
  assign(gemfile,'jgm3.dat'); { text file with coefficients }
  reset(gemfile);             { to open to read }
  { nine strings }
  for i:=1 to 9 do  readln(gemfile); { only to omit }
  while  not eof(gemfile)  do
    begin
      readln(gemfile,n,m,cnm,snm);
      if  ( ( 2 <= n ) and ( n <= 50 )
            and ( 1 <= m ) and ( m <= 50 ) )
        then { all coefficients zonal tesseral sectorial }
          begin
            r:=1.0e-6*sqrt(2.0*(2.0*n+1.0)); { 1.0e-6*sqrt(2*(2n+1)) }
            k:=n+m;
            p:=togetfactom(k);  { (n+m)! }
            k:=n-m;
            q:=togetfactom(k);  { (n-m)! }
            z:=togetfactos(n);  { (2n-1)!! }
            { the first norm
              sqrt(2*(2n+1))*sqrt((n-m)!/(n+m)!) }
            c:=r*sqrt(q/p)*cnm; { the first method }
            s:=r*sqrt(q/p)*snm; { the first method }
            { the second norm
              sqrt(2*(2n+1))*[(2n-1)!!/sqrt((n+m)!*(n-m)!)] }
            a:=r*(z/sqrt(p*q))*cnm; { the second method }
            b:=r*(z/sqrt(p*q))*snm; { the second method }
            { function FloatWithPower from unharstr }
            writeln(n:3,m:3,
                    FloatWithPower(c,20),
                    FloatWithPower(a,20));
            writeln(n:3,m:3,
                    FloatWithPower(s,20),
                    FloatWithPower(b,20));
          end;
    end;
  close(gemfile);             { that is all }
end;
end.
