
 UNIT UnHarStr ; { simple operations with the strings }

 INTERFACE

 Type
   ShortString  =  String ;

 Function WordToFixStr ( w  : Word ; n  : Byte ) : ShortString ;

 Function IntegerToFixStr ( w  : Integer ; n  : Byte ) : ShortString ;

 Function FloatToFixStr ( e  : Extended ;  n , k  : Byte ) : ShortString ;

 Function BlanksToStr ( s  : ShortString ; n  : Byte ) : ShortString ;

 Procedure ToEraseSomeBlanks ( Var  sn  : ShortString ) ;

 Procedure ToEraseAllBlanks ( Var  sn  : ShortString ) ;

 Procedure ToReplaceBlanks ( Var  st  : ShortString ) ;

 Function WithOutDecimalPoint ( st  : ShortString ) : ShortString ;

 Function FloatWithPower ( e  : Extended ;  n  : Byte ) : ShortString ;

 Function GloatWithPower ( e  : Extended ;  n  : Byte ) : ShortString ;

 IMPLEMENTATION

 Function WordToFixStr ( w  : Word ; n  : Byte ) : ShortString ;
 Var
   i  : Byte ;
   s  : ShortString ;
 Begin
   Str(w:n,s);
   For i:=1 To n Do
     If  s[i] = ' '  Then  s[i]:='0';
   WordToFixStr:=s;
 End;

 Function IntegerToFixStr ( w  : Integer ; n  : Byte ) : ShortString ;
 Var
   i  : Byte ;
   s  : ShortString ;
 Begin
   Str(w:n,s);
   For i:=1 To n Do
     If  s[i] = ' '  Then  s[i]:='0';
   IntegerToFixStr:=s;
 End;

 Function FloatToFixStr ( e  : Extended ;  n , k  : Byte ) : ShortString ;
 Var
   i  : Byte ;
   p  : Byte ;
   s  : ShortString ;
 Begin
   Str(e:n:k,s);
   p:=Pos('-',s);
   If  p > 1
     Then
       Begin
         s[p]:='0';
         s[1]:='-';
       End;
   For i:=1 To n Do
     If  s[i] = ' '  Then  s[i]:='0';
   FloatToFixStr:=s;
 End;

 Function BlanksToStr ( s : ShortString ; n  : Byte ) : ShortString ;
 Var
   a  : ShortString ;
   l  : Byte ;
 Begin
   a:=s; { our string }
   l:=Length(a); { length of our string }
   If  l > n
     Then
       Delete(a,n+1,l-n) { length is greater than necessary }
     Else
       While  l < n  Do  { length of our string is less than necessary }
         Begin           { to add blanks if it is needed }
           a:=' '+a;                          { to add one blank forward }
           If  Length(a) < n  Then  a:=a+' '; { to add one blank backward }
           l:=Length(a);
         End;
   BlanksToStr:=a;
 End;

 Procedure ToEraseSomeBlanks ( Var  sn  : ShortString ) ;
 Var
   i,l  : Byte ;
 Begin
   l:=Length(sn);
   For i:=l DownTo 1 Do
     If  sn[i] = ' '
       Then
         Delete(sn,i,1)
       Else
         Exit;
 End;

 Procedure ToEraseAllBlanks ( Var  sn  : ShortString ) ;
 Var
   n  : Byte ;
 Begin
   n:=Pos(' ',sn);
   While  n > 0  Do
     Begin
       Delete(sn,n,1);
       n:=Pos(' ',sn);
     End;
 End;

 Procedure ToReplaceBlanks ( Var  st  : ShortString ) ;
 Var
   i,l,n     : Byte ;
 Begin
   l:=Length(st);
   For i:=1 To l Do
     If  st[i] = ' '
       then  st[i]:='0';
   n:=Pos('+',st);   { may be plus in string }
   if  n > 1
     then
       begin
         st[1]:='+'; { the first character plus }
         st[n]:='0'; { replace by nullo }
       end;
   n:=Pos('-',st);   { may be minus in string }
   if  n > 1
     then
       begin
         st[1]:='-'; { the first character minus }
         st[n]:='0'; { replace by nullo }
       end;
 End;

 Function WithOutDecimalPoint ( st  : ShortString ) : ShortString ;
 Var
   n  : Byte ;
   s  : ShortString ;
 Begin
   s:=st;
   n:=Pos('.',s);
   While  n > 0  Do
     Begin
       Delete(s,n,1);
       n:=Pos('.',s);
     End;
   WithOutDecimalPoint:=s;
 End;

 function FloatWithPower ( e  : Extended ;  n  : Byte ) : ShortString ;
 var
   k  : Byte ;
   s  : ShortString ;
 begin
   k:=n-1;            { a place for blank }
   Str(e:k,s);        { to string in form -x.xxE-xxxx where x integer 0..9 }
   Delete(s,k-3,1);       { to string in form -x.xxE-xxx   short power }
   s[k-5]:='e';             { to string in form -x.xxe-xxx to replace E }
   FloatWithPower:='    '+s; { result with blanks forward }
 end;

 function GloatWithPower ( e  : Extended ;  n  : Byte ) : ShortString ;
 var
   k  : Byte ;
   s  : ShortString ;
 begin
   k:=n-1;            { a place for blank }
   Str(e:k,s);        { to string in form -x.xxE-xxxx where x integer 0..9 }
   s[k-5]:='e';       { to string in form -x.xxe-xxx to replace E }
   GloatWithPower:='   '+s; { result with blanks forward }
 end;

 END.
